//: [Previous](@previous)

import Foundation

var total = Int()
// Why did I declare this?

let a = 10
let b = 20
// Why didn't I declare these

func geekSum(a: Int, b: Int) -> Int {
    return a+b
}
// Hey, what's that?
// This is a function. It's really important to break programs into
// easy to understand chunks.
// so I have my function a name
// and I told it I'm expecting two things, both integers
// and I'm going to call them a and b.
// Finally, I'm going to give back a thing, in this case an integer.

total = geekSum(a: a, b: b)

// This looks really smart. Variables are named, but does it really
// help us figure out what's going on here? If I see that line of code
// month from now, will I know what it means? I'd have to find the geekSum
// function and re-read it and figure out what I wanted it to do.
// That's going to get complicated pretty fast.

// Swift let's us use the code itself as documentation.

// Ok, let's rewrite this so it becomes easier to understand:
func sum(_ left: Int, plus right: Int) -> Int {
    return left+right
}
// _ means I don't have to have the first variable named.
// I know it will always be there, so we're just going to
// assume it's there.
// left is going to be the name of the variable only in the scope of the
// function.
// plus is the name of the second variable. This is what people
// see when they call your function.
// right is the internal name
// it's more complicated when you declare the function, but
// what does it look like when we're using it?

total = sum(a, plus: b)
// Is this easier to read or understand?
// The answer is the same, but the code is a lot easier to read and understand
// that said, it's your responsibility to be clear.
// don't write functions like this:

func liarMinus(_ left: Int, minus right: Int) -> Int {
    return left*right
}

total = liarMinus(a, minus: total)
